/****************************************************************************
**
** Copyright (C) 2008 Nokia Corporation and/or its subsidiary(-ies).
** Contact: Qt Software Information (qt-info@nokia.com)
**
** This file is part of the example classes of the Qt Toolkit.
**
** Commercial Usage
** Licensees holding valid Qt Commercial licenses may use this file in
** accordance with the Qt Commercial License Agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Nokia.
**
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License versions 2.0 or 3.0 as published by the Free
** Software Foundation and appearing in the file LICENSE.GPL included in
** the packaging of this file.  Please review the following information
** to ensure GNU General Public Licensing requirements will be met:
** http://www.fsf.org/licensing/licenses/info/GPLv2.html and
** http://www.gnu.org/copyleft/gpl.html.  In addition, as a special
** exception, Nokia gives you certain additional rights. These rights
** are described in the Nokia Qt GPL Exception version 1.3, included in
** the file GPL_EXCEPTION.txt in this package.
**
** Qt for Windows(R) Licensees
** As a special exception, Nokia, as the sole copyright holder for Qt
** Designer, grants users of the Qt/Eclipse Integration plug-in the
** right for the Qt/Eclipse Integration to link to functionality
** provided by Qt Designer and its related libraries.
**
** If you are unsure which license is appropriate for your use, please
** contact the sales department at qt-sales@nokia.com.
**
****************************************************************************/

/** extended by Martin Witte for kradio4 **/

#ifndef BUTTONFLOWLAYOUT4_H
#define BUTTONFLOWLAYOUT4_H

#include <QtCore/QRect>
#include <QtGui/QLayout>
#include <QtGui/QWidgetItem>

class ButtonFlowLayout4 : public QLayout
{
public:
    ButtonFlowLayout4(QWidget *parent, int margin = 0, int spacing = -1);
    ButtonFlowLayout4(int spacing = -1);
    ~ButtonFlowLayout4();

    void             addItem(QLayoutItem *item);
    Qt::Orientations expandingDirections() const;
    bool             hasHeightForWidth() const;
    int              heightForWidth(int) const;
    int              count() const;
    QLayoutItem     *itemAt(int index) const;
    QSize            minimumSize() const;
    QSize            minimumSize(const QSize &s) const;
    void             setGeometry(const QRect &rect);
    QSize            sizeHint() const;
    QLayoutItem     *takeAt(int index);

private:
    int              doLayout(const QRect &rect, bool testOnly) const;

    QList<QLayoutItem *> m_itemList;
    int                  m_cached_width;
    int                  m_cached_hfw;
};

#endif
